#ifndef _ADATA_DMA_DEMO_DMA_DEMO_H
#define _ADATA_DMA_DEMO_DMA_DEMO_H

#include <exappmessage.h>

using namespace AlphaData::AppFramework;

enum ExitCode {
  ExitCodeSuccess = 0,
  ExitCodeCannotOpenIndex = 100,
  ExitCodeCannotOpenSerial = 101,
  ExitCodeGetCardInfoFailed = 102,
  ExitCodeUnsupportedModel = 103,
  ExitCodeNoDmaEnginesSelected = 104,
  ExitCodeThreadCreateFailed = 105,
  ExitCodeTransferSizeTooBig = 106,
  ExitCodeMapWindowFailed = 107,
  ExitCodeDataErrors = 108,
  ExitCodeBadBitPath = 109,
  ExitCodeFpgaInfoFailed = 110,
  ExitCodeUnrecognizedFpga = 111,
  ExitCodeConfigureFpgaFailed = 112
};

#ifdef __cplusplus
extern "C" {
#endif

int /* ExitCode */
admxrc3DMADemoIndex(
  const TCHAR* pBitPath,
  const TCHAR* pBitFile,
  unsigned int index,
  uint32_t dmaEngineMask,
  uint32_t dmaDirectionMask,
  uint32_t dmaTransferSize,
  unsigned int durationMs,
  unsigned int maxErrorDisplayed,
  int bVerifyData);

int /* ExitCode */
admxrc3DMADemoSN(
  const TCHAR* pBitPath,
  const TCHAR* pBitFile,
  uint32_t serialNumber,
  uint32_t dmaEngineMask,
  uint32_t dmaDirectionMask,
  uint32_t dmaTransferSize,
  unsigned int durationMs,
  unsigned int maxErrorDisplayed,
  int bVerifyData);

#ifdef __cplusplus
}
#endif

extern CExAppMessageDisplay g_dmaDemoMessageDisplay;

#endif
