#ifndef _ADATA_DMA_DEMO_DMA_DEMO_PCIE_H
#define _ADATA_DMA_DEMO_DMA_DEMO_PCIE_H

#include <exappmessage.h>

using namespace AlphaData::AppFramework;

enum ExitCode {
  ExitCodeSuccess = 0,
  ExitCodeCannotOpenIndex = 100,
  ExitCodeCannotOpenSerial = 101,
  ExitCodeGetCardInfoFailed = 102,
  ExitCodeUnsupportedModel = 103,
  ExitCodeNoDmaEnginesSelected = 104,
  ExitCodeThreadCreateFailed = 105,
  ExitCodeTransferSizeTooBig = 106,
  ExitCodeMapWindowFailed = 107,
  ExitCodeDataErrors = 108
};

#ifdef __cplusplus
extern "C" {
#endif

int /* ExitCode */
admxrc3DMADemoPcieIndex(
  unsigned int index,
  uint32_t dmaEngineMask,
  uint32_t dmaDirectionMask,
  uint32_t dmaTransferSize,
  unsigned int durationMs,
  unsigned int maxErrorDisplayed,
  int bVerifyData);

int /* ExitCode */
admxrc3DMADemoPcieSN(
  uint32_t serialNumber,
  uint32_t dmaEngineMask,
  uint32_t dmaDirectionMask,
  uint32_t dmaTransferSize,
  unsigned int durationMs,
  unsigned int maxErrorDisplayed,
  int bVerifyData);

#ifdef __cplusplus
}
#endif

extern CExAppMessageDisplay g_dmaDemoPcieMessageDisplay;

#endif
