# TCL hook script for STEPS.WRITE_BITSTREAM.TCL.PRE

# Workaround for Vivado 2016.1/2 multithreaded write_bitstream issues
# See Answer record 68006, https://www.xilinx.com/support/answers/68006.html
if {[regexp {^2016\.[12].*} [version -short]]} {
  set maxThreads [get_param bitgen.maxThreads]
  if { $maxThreads != 1 } {
    puts "WARNING: param bitgen.maxThreads is not equal to 1 in Vivado 2016.1/2."
    puts "         To avoid seeing this warning, please see Xilinx answer record 68006"
    puts "         and apply the recommended workaround in your init.tcl script."
    puts "         https://www.xilinx.com/support/answers/68006.html"
    set_param bitgen.maxThreads 1
  } else {
    puts "INFO: param bitgen.maxThreads is 1 in Vivado 2016.1/2. No action required."
  }
}
