##-----------------------------------------------------------------------------
##
## (c) Copyright 2012-2012 Xilinx, Inc. All rights reserved.
##
## This file contains confidential and proprietary information
## of Xilinx, Inc. and is protected under U.S. and
## international copyright and other intellectual property
## laws.
##
## DISCLAIMER
## This disclaimer is not a license and does not grant any
## rights to the materials distributed herewith. Except as
## otherwise provided in a valid license issued to you by
## Xilinx, and to the maximum extent permitted by applicable
## law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
## WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
## AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
## BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
## INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
## (2) Xilinx shall not be liable (whether in contract or tort,
## including negligence, or under any other theory of
## liability) for any loss or damage of any kind or nature
## related to, arising under or in connection with these
## materials, including for any direct, or any indirect,
## special, incidental, or consequential loss or damage
## (including loss of data, profits, goodwill, or any type of
## loss or damage suffered as a result of any action brought
## by a third party) even if such damage or loss was
## reasonably foreseeable or Xilinx had been advised of the
## possibility of the same.
##
## CRITICAL APPLICATIONS
## Xilinx products are not designed or intended to be fail-
## safe, or for use in any application requiring fail-safe
## performance, such as life-support or safety devices or
## systems, Class III medical devices, nuclear facilities,
## applications related to the deployment of airbags, or any
## other applications that could lead to death, personal
## injury, or severe property or environmental damage
## (individually and collectively, "Critical
## Applications"). Customer assumes the sole risk and
## liability of any use of Xilinx products in Critical
## Applications, subject only to applicable laws and
## regulations governing limitations on product liability.
##
## THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
## PART OF THIS FILE AT ALL TIMES.
##
##-----------------------------------------------------------------------------


#create_clock -name pcie3_7x_0_sys_clk -period 10 [get_ports pcie100_p]
#create_clock -name rclkin -period 3.333 [get_ports refclk300_p]

set_property max_fanout 50 [get_nets *]


###############################################################################
#
# PCI Express Block placement. This constraint selects the PCI Express
# Block to be used.
#
###############################################################################
set_property LOC PCIE_3_1_X0Y0 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/PCIE_3_1_inst}]

###############################################################################
# Buffer (BRAM) Placement Constraints
###############################################################################

#Request Buffer RAMB Placement

set_property LOC RAMB18_X16Y2 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_req_inst/bram_req_8k_inst/RAMB18E2[0].ramb18e2_inst}]
set_property LOC RAMB18_X16Y3 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_req_inst/bram_req_8k_inst/RAMB18E2[1].ramb18e2_inst}]
set_property LOC RAMB18_X16Y4 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_req_inst/bram_req_8k_inst/RAMB18E2[2].ramb18e2_inst}]
set_property LOC RAMB18_X16Y5 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_req_inst/bram_req_8k_inst/RAMB18E2[3].ramb18e2_inst}]

# Completion Buffer RAMB Placement

set_property LOC RAMB18_X16Y8  [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[0].ramb18e2_inst}]
set_property LOC RAMB18_X16Y9  [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[1].ramb18e2_inst}]
set_property LOC RAMB18_X16Y10 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[2].ramb18e2_inst}]
set_property LOC RAMB18_X16Y11 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[3].ramb18e2_inst}]
set_property LOC RAMB18_X16Y12 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[4].ramb18e2_inst}]
set_property LOC RAMB18_X16Y13 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[5].ramb18e2_inst}]
set_property LOC RAMB18_X16Y14 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[6].ramb18e2_inst}]
set_property LOC RAMB18_X16Y15 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[7].ramb18e2_inst}]


# Replay Buffer RAMB Placement
set_property LOC RAMB36_X16Y9 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_rep_inst/bram_rep_8k_inst/RAMB36E2[0].ramb36e2_inst}]
set_property LOC RAMB36_X16Y10 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_rep_inst/bram_rep_8k_inst/RAMB36E2[1].ramb36e2_inst}]


###############################################################################
# Timing Constraints
###############################################################################
#


# Set Divide By 2
set_case_analysis 1 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_userclk/DIV[0]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_userclk/DIV[1]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_userclk/DIV[2]}]
# Set Divide By 2
set_case_analysis 1 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_pclk/DIV[0]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_pclk/DIV[1]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_pclk/DIV[2]}]
# Set Divide By 4
set_case_analysis 1 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/bufg_mcap_clk/DIV[0]}]
set_case_analysis 1 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/bufg_mcap_clk/DIV[1]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/bufg_mcap_clk/DIV[2]}]
# Set Divide By 1
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_coreclk/DIV[0]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_coreclk/DIV[1]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_coreclk/DIV[2]}]




# UltraScale FPGAs Transceivers Wizard IP core-level XDC file
# ----------------------------------------------------------------------------------------------------------------------

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y0
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
#create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[24].*gen_gthe3_channel_inst[0].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y0 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[24].*gen_gthe3_channel_inst[0].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin AP1 [get_ports gthrxn_in[0]]
#set_property package_pin AP2 [get_ports gthrxp_in[0]]
#set_property package_pin AN3 [get_ports gthtxn_out[0]]
#set_property package_pin AN4 [get_ports gthtxp_out[0]]

# CPLL calibration block constraints
#create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y1
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
#create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[24].*gen_gthe3_channel_inst[1].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y1 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[24].*gen_gthe3_channel_inst[1].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin AM1 [get_ports gthrxn_in[1]]
#set_property package_pin AM2 [get_ports gthrxp_in[1]]
#set_property package_pin AM5 [get_ports gthtxn_out[1]]
#set_property package_pin AM6 [get_ports gthtxp_out[1]]

# CPLL calibration block constraints
#create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y2
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
#create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[24].*gen_gthe3_channel_inst[2].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y2 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[24].*gen_gthe3_channel_inst[2].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin AK1 [get_ports gthrxn_in[2]]
#set_property package_pin AK2 [get_ports gthrxp_in[2]]
#set_property package_pin AL3 [get_ports gthtxn_out[2]]
#set_property package_pin AL4 [get_ports gthtxp_out[2]]

# CPLL calibration block constraints
#create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y3
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
#create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[24].*gen_gthe3_channel_inst[3].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y3 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[24].*gen_gthe3_channel_inst[3].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin AJ3 [get_ports gthrxn_in[3]]
#set_property package_pin AJ4 [get_ports gthrxp_in[3]]
#set_property package_pin AK5 [get_ports gthtxn_out[3]]
#set_property package_pin AK6 [get_ports gthtxp_out[3]]

# CPLL calibration block constraints
#create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y4
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
#create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[25].*gen_gthe3_channel_inst[0].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y4 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[25].*gen_gthe3_channel_inst[0].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin AH1 [get_ports gthrxn_in[4]]
#set_property package_pin AH2 [get_ports gthrxp_in[4]]
#set_property package_pin AH5 [get_ports gthtxn_out[4]]
#set_property package_pin AH6 [get_ports gthtxp_out[4]]

# CPLL calibration block constraints
#create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y5
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
#create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[25].*gen_gthe3_channel_inst[1].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y5 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[25].*gen_gthe3_channel_inst[1].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin AF1 [get_ports gthrxn_in[5]]
#set_property package_pin AF2 [get_ports gthrxp_in[5]]
#set_property package_pin AG3 [get_ports gthtxn_out[5]]
#set_property package_pin AG4 [get_ports gthtxp_out[5]]

# CPLL calibration block constraints
#create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y6
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
#create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[25].*gen_gthe3_channel_inst[2].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y6 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[25].*gen_gthe3_channel_inst[2].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin AD1 [get_ports gthrxn_in[6]]
#set_property package_pin AD2 [get_ports gthrxp_in[6]]
#set_property package_pin AE3 [get_ports gthtxn_out[6]]
#set_property package_pin AE4 [get_ports gthtxp_out[6]]

# CPLL calibration block constraints
#create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y7
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
#create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[25].*gen_gthe3_channel_inst[3].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y7 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[25].*gen_gthe3_channel_inst[3].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin AB1 [get_ports gthrxn_in[7]]
#set_property package_pin AB2 [get_ports gthrxp_in[7]]
#set_property package_pin AC3 [get_ports gthtxn_out[7]]
#set_property package_pin AC4 [get_ports gthtxp_out[7]]

# CPLL calibration block constraints
#create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*bufg_gt_txoutclkmon_inst/O}]
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
#set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet


# False path constraints
# ----------------------------------------------------------------------------------------------------------------------

#set_false_path -to [get_cells -hierarchical -filter {NAME =~ *bit_synchronizer*inst/i_in_meta_reg}]
#set_false_path -to [get_cells -hierarchical -filter {NAME =~ *reset_synchronizer*inst/rst_in_*_reg}]


# Cross clock constraints
set pcie_pipe [get_clocks -of_objects [get_pins -hier -filter {NAME =~ *gen_synth.adm_xrc_ku1_i/adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_pclk/O}]]
set pcie_aclk [get_clocks -of_objects [get_pins -hier -filter {NAME =~ *gen_synth.adm_xrc_ku1_i/adb3_core_bridge_1/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_userclk/O}]]
set pcie_i    [get_clocks -of_objects [get_pins -hier -filter {NAME =~ *gen_synth.adm_xrc_ku1_i/adm_xrc_ku1_model_1/model_clocks_ku1_0/pll_lclk/CLKOUT1}]]

set_false_path -from $pcie_pipe -to [get_clocks pcie3_7x_0_sys_clk]
set_max_delay  -from $pcie_pipe -to [get_clocks pcie3_7x_0_sys_clk] 4.0
set_false_path -from [get_clocks pcie3_7x_0_sys_clk] -to $pcie_pipe
set_max_delay  -from [get_clocks pcie3_7x_0_sys_clk] -to $pcie_pipe 4.0

set_false_path -from [get_clocks pcie3_7x_0_sys_clk] -to $pcie_aclk
set_max_delay  -from [get_clocks pcie3_7x_0_sys_clk] -to $pcie_aclk 4.0
set_false_path -from $pcie_aclk -to [get_clocks pcie3_7x_0_sys_clk]
set_max_delay  -from $pcie_aclk -to [get_clocks pcie3_7x_0_sys_clk] 4.0

set_false_path -from $pcie_aclk -to $pcie_pipe
set_max_delay  -from $pcie_aclk -to $pcie_pipe 4.0
set_false_path -from $pcie_pipe -to $pcie_aclk
set_max_delay  -from $pcie_pipe -to $pcie_aclk 4.0

set_false_path -from $pcie_i -to $pcie_aclk
set_max_delay  -from $pcie_i -to $pcie_aclk 4.0
set_false_path -from $pcie_aclk -to $pcie_i
set_max_delay  -from $pcie_aclk -to $pcie_i 4.0

#set_false_path -from [get_clocks s_axi_aclk] -to [get_clocks CLKOUT1]
#set_max_delay -from [get_clocks s_axi_aclk] -to [get_clocks CLKOUT1] 4.000
#set_false_path -from [get_clocks CLKOUT1] -to [get_clocks s_axi_aclk]
#set_max_delay -from [get_clocks CLKOUT1] -to [get_clocks s_axi_aclk] 4.000

#set_false_path -from [get_clocks s_axi_aclk] -to [get_clocks I]
#set_max_delay -from [get_clocks s_axi_aclk] -to [get_clocks I] 4.000
#set_false_path -from [get_clocks I] -to [get_clocks s_axi_aclk]
#set_max_delay -from [get_clocks I] -to [get_clocks s_axi_aclk] 4.000

set_false_path -from [get_pins -hier -filter {NAME =~*adb3_core_bridge_1/pcie_rst_held*/C}]

#create_clock -name avr_mon_clk -period 20.000 [get_ports avr_clk]

set_false_path -from [get_clocks avr_mon_clk] -to $pcie_i
set_max_delay  -from [get_clocks avr_mon_clk] -to $pcie_i 20.0
set_false_path -from $pcie_i -to [get_clocks avr_mon_clk]
set_max_delay  -from $pcie_i -to [get_clocks avr_mon_clk] 20.0


set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gen_gthe3_channel_inst[?].GTHE3_CHANNEL_PRIM_INST/CPLLLOCK}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gen_gthe3_channel_inst[?].GTHE3_CHANNEL_PRIM_INST/GTPOWERGOOD}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gen_gthe3_channel_inst[?].GTHE3_CHANNEL_PRIM_INST/PCIESYNCTXSYNCDONE}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gen_gthe3_channel_inst[?].GTHE3_CHANNEL_PRIM_INST/TXPRGDIVRESETDONE}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gen_gthe3_channel_inst[?].GTHE3_CHANNEL_PRIM_INST/RXELECIDLE}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gthe3_common_gen.GTHE3_COMMON_PRIM_INST/QPLL1LOCK}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*pcie3_uscale_wrapper_inst/PCIE_3_1_inst/PCIEPERST0B}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *gen_synth.adm_xrc_ku1_i/adm_xrc_ku1_model_1/model_clocks_ku1_0/pll_lclk/LOCKED}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *gen_synth.adm_xrc_ku1_i/adm_xrc_ku1_model_1/fpga_int_0/gen_capture_irq[*].edge_detected_reg[*]/CLR}]
