--
-- pulse_sync2.vhd - entity "pulse_sync2"
--
-- SYNTHESISABLE
--
-- This entity retimes pulses input from one clock domain into pulses for
-- another clock domain.
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

library unisim;
use unisim.vcomponents.all;

library work;
-- use work.virtex.all;

entity pulse_sync2 is
    port(
        ar : in  std_logic;
        ik : in  std_logic;
        i  : in  std_logic;
        ok : in  std_logic;
        o  : out std_logic);
end;

architecture rtl of pulse_sync2 is

    signal rst, x, xy, y, yz, z : std_logic;
    
    signal logic1 : std_logic;

    --
    -- With synpro 7.5.1 and ISE 6.2, using 'rst' as CLR for 'x' FF doesn't work.
    -- Don't know why.
    --

begin

    logic1 <= '1';

    o <= z;

    rst <= ar or z;

    gen_x : FDCE
        port map(
            CLR => z,
            C => ik,
            D => logic1,
            CE => i,
            Q => x);

    xy <= x and not z;

    gen_y : FDC
        port map(
            CLR => ar,
            C => ok,
            D => xy,
            Q => y);

    yz <= y and not z;

    gen_z : FDC
        port map(
            CLR => ar,
            C => ok,
            D => yz,
            Q => z);

end;
