#ifndef _ADATA_COMMONENDIAN_H
#define _ADATA_COMMONENDIAN_H

#if defined(_M_IX86) || defined(_M_IA64) || defined(_M_X64)

# if defined(_MSC_VER)

#   include <intrin.h>

#   define cpu_to_be16(x) ((UINT16)_byteswap_ushort((unsigned short)(x)))
#   define cpu_to_be32(x) ((UINT32)_byteswap_ulong((unsigned long)(x)))
#   define cpu_to_be64(x) ((UINT64)_byteswap_uint64((unsigned __int64)(x)))

# elif defined(__GNUC__)

#   define cpu_to_be16(x) (__builtin_bswap16(x))
#   define cpu_to_be32(x) (__builtin_bswap32(x))
#   define cpu_to_be64(x) (__builtin_bswap64(x))

# else

/* Roll our own swap functions */
static UINT16 cpu_to_be16(UINT16 x) {
  return (UINT16)((x >> 8) & 0x00FF) | (UINT16)((x << 8) & 0xFF00);
}

static UINT32 cpu_to_be32(UINT32 x) {
  return (UINT32)((x >> 24) & 0x000000FF) | (UINT32)((x >> 8)  & 0x0000FF00) |
         (UINT32)((x << 8)  & 0x00FF0000) | (UINT32)((x << 24) & 0xFF000000);
}

static UINT64 cpu_to_be64(UINT64 x) {
  return (UINT64)((x >> 56) & 0x00000000000000FF) | (UINT64)((x >> 40) & 0x000000000000FF00) |
         (UINT64)((x >> 24) & 0x0000000000FF0000) | (UINT64)((x >> 8)  & 0x00000000FF000000) |
         (UINT64)((x << 8)  & 0x000000FF00000000) | (UINT64)((x << 24) & 0x0000FF0000000000) |
         (UINT64)((x << 40) & 0x00FF000000000000) | (UINT64)((x << 56) & 0xFF00000000000000);
}

# endif

# define cpu_to_be8(x) x
# define cpu_to_le8(x) x
# define cpu_to_le16(x) x
# define cpu_to_le32(x) x
# define cpu_to_le64(x) x

# define be8_to_cpu(x) x
# define be16_to_cpu(x) cpu_to_be16(x)
# define be32_to_cpu(x) cpu_to_be32(x)
# define be64_to_cpu(x) cpu_to_be64(x)
# define le8_to_cpu(x) x
# define le16_to_cpu(x) x
# define le32_to_cpu(x) x
# define le64_to_cpu(x) x

#else

# error Unsupported CPU architecture - please fix this file in order to support your CPU architecture!

#endif

#endif
