#pragma once

#include <objmodel.h>

#ifdef _DEBUG
# define new DEBUG_NEW
#endif

class CEnterEdit : public CEdit {
	DECLARE_DYNAMIC(CEnterEdit)

protected:

  DECLARE_MESSAGE_MAP()

protected:
  bool ValidateText();

protected:
  afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
};

class CClockGenWnd : public CWnd, public IClockGenWnd
{
	DECLARE_DYNAMIC(CClockGenWnd)

public:
	CClockGenWnd(ISysMonWnd* pParent, bool_t bVisible);
	virtual ~CClockGenWnd();
  // ISensorInfoWnd interface
  void deviceChanged();
  void numDeviceChanged();
  control_handle_t getNativeControl() { return *this; }
  ISysMonWnd* getParent() const { return m_pParent; }
  void update();

protected:
  ISysMonWnd* m_pParent;
  unsigned int m_numDevice;
  CFont m_font;
  CBrush m_bgBrush;
  CListCtrl m_listCtl;
  CButton m_allowChangeCtl;
  CStatic m_allowChangeLabelCtl;
  CEnterEdit m_freqEditCtl;
  BOOL m_bInAdminGroup;
  BOOL m_bIsElevated;
  unsigned int m_freqEditIndex;

protected:

  DECLARE_MESSAGE_MAP()

protected:
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnSize(UINT nType, int cx, int cy);
  afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
  afx_msg void OnButtonAllowChanges();
  afx_msg void OnListDblClk(NMHDR* pNotifyStruct, LRESULT* pResult);
  afx_msg void OnFreqEditSetFocus();
  afx_msg void OnFreqEditKillFocus();
  afx_msg LRESULT OnFreqEditOk(WPARAM wParam, LPARAM lParam);
};
